<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>iterators-vs-generators</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
</head>
<body>
<h1 id="iterators-and-iterables"><strong>Iterators and Iterables</strong></h1>
<p>Iterators are rather strictly defined: they are object (the iterators) which contains a <code>next</code> (and possibly a few other) function. Every time the <code>next</code> function is called, it is expected to return an object with two properties:</p>
<ul>
<li><code>value</code>: the current value of the iterator</li>
<li><code>done</code>: is the iterator finished?</li>
</ul>
<p>An iterable on the other hand is an object which has a property with a <code>Symbol.iterator</code> key (which represents the well know symbol <code>@@iterator</code>). That key contains a function, which when called, returns a new iterator. An example of an iterable:</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">const</span> list <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-2" title="2">    <span class="dt">entries</span><span class="op">:</span> <span class="op">{</span> <span class="dv">0</span><span class="op">:</span> <span class="st">&#39;a&#39;</span><span class="op">,</span> <span class="dv">1</span><span class="op">:</span> <span class="st">&#39;b&#39;</span> <span class="op">},</span></a>
<a class="sourceLine" id="cb1-3" title="3">    [<span class="va">Symbol</span>.<span class="at">iterator</span>]<span class="op">:</span> <span class="kw">function</span>()<span class="op">{</span></a>
<a class="sourceLine" id="cb1-4" title="4">        <span class="kw">let</span> counter <span class="op">=</span> <span class="dv">0</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-5" title="5">        <span class="kw">const</span> entries <span class="op">=</span> <span class="kw">this</span>.<span class="at">entries</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-6" title="6">        <span class="cf">return</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-7" title="7">            <span class="dt">next</span><span class="op">:</span> <span class="kw">function</span>()<span class="op">{</span></a>
<a class="sourceLine" id="cb1-8" title="8">                <span class="cf">return</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb1-9" title="9">                    <span class="dt">value</span><span class="op">:</span> entries[counter]<span class="op">,</span></a>
<a class="sourceLine" id="cb1-10" title="10">                    <span class="dt">done</span><span class="op">:</span> <span class="op">!</span><span class="va">entries</span>.<span class="at">hasOwnProperty</span>(counter<span class="op">++</span>)</a>
<a class="sourceLine" id="cb1-11" title="11">                <span class="op">}</span></a>
<a class="sourceLine" id="cb1-12" title="12">            <span class="op">}</span></a>
<a class="sourceLine" id="cb1-13" title="13">        <span class="op">}</span></a>
<a class="sourceLine" id="cb1-14" title="14">    <span class="op">}</span></a>
<a class="sourceLine" id="cb1-15" title="15"><span class="op">};</span></a></code></pre></div>
<p>Their main purpose, as their name suggests, is to provide an interface which can be iterated:</p>
<div class="sourceCode" id="cb2"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="cf">for</span> (<span class="kw">let</span> item <span class="kw">of</span> list) <span class="op">{</span> <span class="va">console</span>.<span class="at">log</span>(item)<span class="op">;</span> <span class="op">}</span></a>
<a class="sourceLine" id="cb2-2" title="2"><span class="co">// &#39;a&#39;</span></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="co">// &#39;b&#39;</span></a></code></pre></div>
<h1 id="generators"><strong>Generators</strong></h1>
<p>Generators on the other hand are much more versatile. It helps to think of them as functions which can be paused and resumed.</p>
<p>While they can be iterated (their iterables provide a <code>next</code> method), they can implement much more sophisticated procedures and provide a input/output communication through their <code>next</code> method.</p>
<p>A simple generator:</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">function</span> <span class="op">*</span><span class="at">mygen</span> () <span class="op">{</span></a>
<a class="sourceLine" id="cb3-2" title="2">   <span class="kw">let</span> myVal <span class="op">=</span> <span class="kw">yield</span> <span class="dv">12</span><span class="op">;</span></a>
<a class="sourceLine" id="cb3-3" title="3">   <span class="cf">return</span> myVal <span class="op">*</span> <span class="dv">2</span><span class="op">;</span></a>
<a class="sourceLine" id="cb3-4" title="4"><span class="op">}</span></a>
<a class="sourceLine" id="cb3-5" title="5"></a>
<a class="sourceLine" id="cb3-6" title="6"><span class="kw">const</span> myIt <span class="op">=</span> <span class="at">mygen</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb3-7" title="7"></a>
<a class="sourceLine" id="cb3-8" title="8"><span class="kw">const</span> firstGenValue <span class="op">=</span> <span class="va">myIt</span>.<span class="at">next</span>().<span class="at">value</span><span class="op">;</span></a>
<a class="sourceLine" id="cb3-9" title="9"><span class="co">// Generator is paused and yields the first value</span></a>
<a class="sourceLine" id="cb3-10" title="10"></a>
<a class="sourceLine" id="cb3-11" title="11"><span class="kw">const</span> result <span class="op">=</span> <span class="va">myIt</span>.<span class="at">next</span>(firstGenValue <span class="op">*</span> <span class="dv">2</span>).<span class="at">value</span><span class="op">;</span></a>
<a class="sourceLine" id="cb3-12" title="12"></a>
<a class="sourceLine" id="cb3-13" title="13"><span class="va">console</span>.<span class="at">log</span>(result)<span class="op">;</span> <span class="co">// 48</span></a></code></pre></div>
<h3 id="generator-delegation"><strong>Generator delegation</strong></h3>
<p>Generators can delegate to another generator:</p>
<div class="sourceCode" id="cb4"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="kw">function</span> <span class="op">*</span><span class="at">mydelgen</span>(val) <span class="op">{</span></a>
<a class="sourceLine" id="cb4-2" title="2">    <span class="kw">yield</span> val <span class="op">*</span> <span class="dv">2</span><span class="op">;</span></a>
<a class="sourceLine" id="cb4-3" title="3"><span class="op">}</span></a>
<a class="sourceLine" id="cb4-4" title="4"></a>
<a class="sourceLine" id="cb4-5" title="5"><span class="kw">function</span> <span class="op">*</span><span class="at">mygen</span> () <span class="op">{</span></a>
<a class="sourceLine" id="cb4-6" title="6">    <span class="kw">let</span> myVal <span class="op">=</span> <span class="kw">yield</span> <span class="dv">12</span><span class="op">;</span></a>
<a class="sourceLine" id="cb4-7" title="7">    <span class="kw">yield</span><span class="op">*</span> <span class="at">mydelgen</span>(myVal)<span class="op">;</span> <span class="co">// delegate to another generator</span></a>
<a class="sourceLine" id="cb4-8" title="8"><span class="op">}</span></a>
<a class="sourceLine" id="cb4-9" title="9"></a>
<a class="sourceLine" id="cb4-10" title="10"><span class="kw">const</span> myIt <span class="op">=</span> <span class="at">mygen</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb4-11" title="11"><span class="kw">const</span> val <span class="op">=</span> <span class="va">myIt</span>.<span class="at">next</span>().<span class="at">value</span><span class="op">;</span></a>
<a class="sourceLine" id="cb4-12" title="12"><span class="va">console</span>.<span class="at">log</span>(val)<span class="op">;</span></a>
<a class="sourceLine" id="cb4-13" title="13"><span class="va">console</span>.<span class="at">log</span>(<span class="va">myIt</span>.<span class="at">next</span>(val).<span class="at">value</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb4-14" title="14"><span class="va">console</span>.<span class="at">log</span>(<span class="va">myIt</span>.<span class="at">next</span>().<span class="at">value</span>)<span class="op">;</span></a></code></pre></div>
<h3 id="generators-promises"><strong>Generators &amp; Promises</strong></h3>
<p>Generators and Promises together can create a sort of automatic asynchronous iterator with the help of utilities such as <a href="https://github.com/tj/co">co</a>.</p>
<div class="sourceCode" id="cb5"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="at">co</span>(<span class="kw">function</span> <span class="op">*</span>()<span class="op">{</span></a>
<a class="sourceLine" id="cb5-2" title="2">  <span class="co">// resolve multiple promises in parallel</span></a>
<a class="sourceLine" id="cb5-3" title="3">  <span class="kw">let</span> a <span class="op">=</span> <span class="va">Promise</span>.<span class="at">resolve</span>(<span class="dv">1</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-4" title="4">  <span class="kw">let</span> b <span class="op">=</span> <span class="va">Promise</span>.<span class="at">resolve</span>(<span class="dv">2</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-5" title="5">  <span class="kw">let</span> c <span class="op">=</span> <span class="va">Promise</span>.<span class="at">resolve</span>(<span class="dv">3</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-6" title="6">  <span class="kw">let</span> res <span class="op">=</span> <span class="kw">yield</span> [a<span class="op">,</span> b<span class="op">,</span> c]<span class="op">;</span></a>
<a class="sourceLine" id="cb5-7" title="7">  <span class="va">console</span>.<span class="at">log</span>(res)<span class="op">;</span></a>
<a class="sourceLine" id="cb5-8" title="8">  <span class="co">// =&gt; [1, 2, 3]</span></a>
<a class="sourceLine" id="cb5-9" title="9"><span class="op">}</span>).<span class="at">catch</span>(onerror)<span class="op">;</span></a></code></pre></div>
<p>So in conclusion one could say that the main purpose of iterators is to create an interface for custom objects to be iterated, whereas generators provide a plethora of possibilities for synchronous and asynchronous workflows:</p>
<ul>
<li>stateful functions</li>
<li>generator delegation</li>
<li>generators &amp; promises</li>
</ul>
</body>
</html>
